package com.tzld.piaoquan.longarticle.utils.other;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.ArrayList;
import java.util.List;

public class DouyinSearch {

    public static void main(String[] args) {
        List<String> sensitiveWords = new ArrayList<>();
        System.out.println(douyinSearch("你好", sensitiveWords, ""));
    }

    public static List<JSONObject> douyinSearch(String keyword, List<String> sensitiveWords, String traceId) {
        String url = "http://8.217.190.241:8888/crawler/dou_yin/top_hub_content";
        JSONObject payload = new JSONObject();
        payload.put("keyword", keyword);
        payload.put("category", "全部");
        payload.put("period", "近90天");
        payload.put("content_modal", "视频");
        payload.put("cursor", "");

        HttpResponse response = HttpRequest.post(url)
                .header("Content-Type", "application/json")
                .body(payload.toString())
                .execute();

        List<JSONObject> resultList = new ArrayList<>();

        try {
            JSONObject jsonResponse = JSONObject.parseObject(response.body());
            JSONArray dtList = jsonResponse.getJSONObject("data").getJSONArray("data");
//            List<JSONObject> dtList = jsonResponse.getByPath("data.data", List.class);
            for (int i = 0; i < dtList.size(); i++) {
                JSONObject obj = dtList.getJSONObject(i);
                try {
                    String title = obj.getString("video_desc");
                    String videoId = obj.getString("video_id");
                    int duration = obj.getInteger("duration");

                    if (sensitiveFlag(sensitiveWords.toString(), title) && duration < 30000) {
                        JSONObject res = douyinDetail(videoId);
                        if (res != null) {
                            resultList.add(res);
                        }
                    }
                } catch (Exception e) {
                    System.out.println(e.getMessage());
                    // 处理异常
                }
            }
            return resultList;
        } catch (Exception e) {
            return new ArrayList<>();
        }
    }

    public static JSONObject douyinDetail(String videoId) {
        System.out.println(videoId);
        String url = "http://8.217.190.241:8888/crawler/dou_yin/detail";
        JSONObject payload = new JSONObject();
        payload.put("content_id", videoId);

        HttpResponse response = HttpRequest.post(url)
                .header("Content-Type", "application/json")
                .body(payload.toString())
                .execute();

        JSONObject videoInfo = JSONObject.parseObject(response.body()).getJSONObject("data").getJSONObject("data");
        if ("note".equals(videoInfo.getString("content_type"))) {
            return null;
        } else {
            return videoInfo;
        }
    }

    private static boolean sensitiveFlag(String sensitiveWords, String title) {
        // 实现敏感词检查逻辑
        return true; // 示例
    }

}


